/*
*
*	DLC and CL layer of RF Main Stack Implementaion
*	DLC_cl.c
*	TecO, University of Karlsruhe
*	Author:		Michael Beigl
*	Date:		6.3.2002
*	Version:        0.1
*	known bugs:
*	todo:
*	Smartits Stack mac & cl layerwith
*
*/

    #include <sys/types.h>
	#include <winsock2.h>
#include <stdio.h>

#include "common.h"
#include "dlc.h"

void DLC_SendPacket(UInt8 l)
{
		int err; 
		
		err = sendto ( sockfd, rf_buffer_out,  l, 0, (SOCKADDR *) &server_addr, 
			sizeof ( SOCKADDR_IN ) );
		if (err>0) sequenceNo++;
}

/////////////////////////////////////////////////////////////
//
//		CL Functions

//#inline
void CL_send(UInt8 aclsize)
{
  unsigned short crc;
  unsigned short i;

//  rf_buffer_out[BUF_SIZE_POS] = aclsize + CL_SIZE-BUF_SIZE_POS-1;
  rf_buffer_out[BUF_SEQ_POS]	= sequenceNo;	// rf packet sequenceNo
  crc = 0;
  for (i=0; i<aclsize+CL_SIZE-CRC_LEN; i++) CRC16(rf_buffer_out[i],&crc);

  rf_buffer_out[aclsize+CL_SIZE-CRC_LEN] = ((UInt8*)(&crc))[1];
  rf_buffer_out[aclsize+CL_SIZE-CRC_LEN+1] = ((UInt8*)(&crc))[0];

  //memcpy(&(rf_buffer_out[aclsize+CL_SIZE-CRC_LEN]), &crc, CRC_LEN);
  DLC_SendPacket( aclsize+CL_SIZE);
}